package com.blamejared.compat.botania.lexicon.pages;

import vazkii.botania.api.lexicon.LexiconPage;
import vazkii.botania.api.lexicon.LexiconEntry;
import java.util.List;
import vazkii.botania.common.lexicon.page.PagePetalRecipe;
import com.blamejared.mtlib.helpers.InputHelper;
import vazkii.botania.api.recipe.RecipePetals;
import java.util.ArrayList;
import crafttweaker.CraftTweakerAPI;
import com.blamejared.compat.botania.BotaniaHelper;
import crafttweaker.api.item.IIngredient;
import crafttweaker.api.item.IItemStack;
import crafttweaker.IAction;

public class AddPagePetal implements IAction
{
    private String name;
    private String entry;
    private int page_number;
    private IItemStack[] outputs;
    private IIngredient[][] inputs;
    
    public AddPagePetal(final String name, final String entry, final int page_number, final IItemStack[] outputs, final IIngredient[][] inputs) {
        this.name = name;
        this.entry = entry;
        this.page_number = page_number;
        this.outputs = outputs;
        this.inputs = inputs;
    }
    
    public void apply() {
        final LexiconEntry lexiconEntry = BotaniaHelper.findEntry(this.entry);
        if (lexiconEntry == null) {
            CraftTweakerAPI.getLogger().logError("Cannot find lexicon entry " + this.entry);
            return;
        }
        if (this.page_number > lexiconEntry.pages.size()) {
            CraftTweakerAPI.getLogger().logError("Page Number " + this.page_number + " out of bounds for " + this.entry);
            return;
        }
        if (this.outputs.length != this.inputs.length) {
            CraftTweakerAPI.getLogger().logError("Length of input and output must match");
            return;
        }
        final List<RecipePetals> recipes = new ArrayList<RecipePetals>();
        for (int i = 0; i < this.outputs.length; ++i) {
            recipes.add(new RecipePetals(InputHelper.toStack(this.outputs[i]), InputHelper.toObjects(this.inputs[i])));
        }
        final LexiconPage page = (LexiconPage)new PagePetalRecipe(this.name, (List)recipes);
        lexiconEntry.pages.add(this.page_number, page);
    }
    
    public String describe() {
        return "Adding Lexicon Page: " + this.name;
    }
}
